"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _decurve = _interopRequireDefault(require("./decurve"));

var _helpers = require("./helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var length = function length(shape, accuracy) {
  var s = (0, _decurve["default"])(shape, accuracy);
  return s.reduce(function (currentLength, _ref, i) {
    var x2 = _ref.x,
        y2 = _ref.y,
        moveTo = _ref.moveTo;

    if (!moveTo) {
      var _s = s[i - 1],
          x1 = _s.x,
          y1 = _s.y;
      currentLength += (0, _helpers.linearLength)(x1, y1, x2, y2);
    }

    return currentLength;
  }, 0);
};

var _default = length;
exports["default"] = _default;