import decurve from './decurve';
import { getShapeArray } from './helpers';

var boundingBox = function boundingBox(s) {
  var bottom;
  var left;
  var right;
  var top;
  var shapes = getShapeArray(s);
  shapes.map(function (shape) {
    return decurve(shape).map(function (_ref) {
      var x = _ref.x,
          y = _ref.y;

      if (typeof bottom !== 'number' || y > bottom) {
        bottom = y;
      }

      if (typeof left !== 'number' || x < left) {
        left = x;
      }

      if (typeof right !== 'number' || x > right) {
        right = x;
      }

      if (typeof top !== 'number' || y < top) {
        top = y;
      }
    });
  });
  return {
    bottom: bottom,
    center: {
      x: left + (right - left) / 2,
      y: top + (bottom - top) / 2
    },
    left: left,
    right: right,
    top: top
  };
};

export default boundingBox;