import decurve from './decurve';
import { linearLength } from './helpers';

var length = function length(shape, accuracy) {
  var s = decurve(shape, accuracy);
  return s.reduce(function (currentLength, _ref, i) {
    var x2 = _ref.x,
        y2 = _ref.y,
        moveTo = _ref.moveTo;

    if (!moveTo) {
      var _s = s[i - 1],
          x1 = _s.x,
          y1 = _s.y;
      currentLength += linearLength(x1, y1, x2, y2);
    }

    return currentLength;
  }, 0);
};

export default length;